// Download.cpp : implementation file
//

#include "stdafx.h"
#include "UrlObj.h"
#include "Download.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDownload

IMPLEMENT_DYNCREATE(CDownload, CCmdTarget)

CDownload::CDownload()
{
}

CDownload::CDownload(CFormView* pView)
{
	m_pView = pView;
}

CDownload::~CDownload()
{
}


BEGIN_MESSAGE_MAP(CDownload, CCmdTarget)
	//{{AFX_MSG_MAP(CDownload)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_INTERFACE_MAP(CDownload, CCmdTarget)
    INTERFACE_PART(CDownload, IID_IBindStatusCallback, BindStatusCallback)
	INTERFACE_PART(CDownload, IID_IWindowForBindingUI, WindowForBindingUI)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDownload message handlers

STDMETHODIMP_(ULONG) CDownload::XBindStatusCallback::AddRef()
{   
    METHOD_PROLOGUE(CDownload, BindStatusCallback)
    return pThis->ExternalAddRef();
}   

STDMETHODIMP_(ULONG) CDownload::XBindStatusCallback::Release()
{   
    METHOD_PROLOGUE(CDownload, BindStatusCallback)
    return pThis->ExternalRelease();
}   

STDMETHODIMP CDownload::XBindStatusCallback::QueryInterface(REFIID iid, void** ppvObj)
{   
    METHOD_PROLOGUE(CDownload, BindStatusCallback)
	return (HRESULT)pThis->ExternalQueryInterface(&iid, ppvObj) ;
}   

STDMETHODIMP CDownload::XBindStatusCallback::OnStartBinding(DWORD grfBSCOption, IBinding* pbinding)
{
    METHOD_PROLOGUE(CDownload, BindStatusCallback)
	return S_OK;
}

STDMETHODIMP CDownload::XBindStatusCallback::GetPriority(LONG* pnPriority) 
{
    METHOD_PROLOGUE(CDownload, BindStatusCallback)
	return E_NOTIMPL;
}

STDMETHODIMP CDownload::XBindStatusCallback::OnLowResource(DWORD dwReserved)
{
    METHOD_PROLOGUE(CDownload, BindStatusCallback)
	return E_NOTIMPL;
}

STDMETHODIMP CDownload::XBindStatusCallback::OnProgress(ULONG ulProgress, ULONG ulProgressMax, ULONG ulStatusCode, LPCWSTR szStatusText) 
{
    METHOD_PROLOGUE(CDownload, BindStatusCallback)

	TRACE("Downloaded : %d bytes of %d \n", ulProgress, (ulProgress>ulProgressMax)?ulProgress:ulProgressMax);
	return NOERROR;
}

STDMETHODIMP CDownload::XBindStatusCallback::OnStopBinding(HRESULT hrResult, LPCWSTR szError) 
{
    METHOD_PROLOGUE(CDownload, BindStatusCallback)
	return S_OK;
}

STDMETHODIMP CDownload::XBindStatusCallback::GetBindInfo(DWORD* pgrfBINDF, BINDINFO* pbindinfo) 
{
    METHOD_PROLOGUE(CDownload, BindStatusCallback)
	return S_OK;
}

STDMETHODIMP CDownload::XBindStatusCallback::OnDataAvailable(DWORD grfBSCF, DWORD dwSize, FORMATETC *pfmtetc, STGMEDIUM* pstgmed) 
{
    METHOD_PROLOGUE(CDownload, BindStatusCallback)
	return S_OK;
}

STDMETHODIMP CDownload::XBindStatusCallback::OnObjectAvailable(REFIID riid, IUnknown* punk) 
{
    METHOD_PROLOGUE(CDownload, BindStatusCallback)

	if (riid != IID_IClassFactory || punk == NULL)
		return E_INVALIDARG;

	pThis->m_pView->PostMessage(WM_ONSTOPBINDING, (WPARAM)punk);

	return S_OK;
}

STDMETHODIMP_(ULONG) CDownload::XWindowForBindingUI::AddRef()
{   
    METHOD_PROLOGUE(CDownload, WindowForBindingUI)
    return pThis->ExternalAddRef();
}   

STDMETHODIMP_(ULONG) CDownload::XWindowForBindingUI::Release()
{   
    METHOD_PROLOGUE(CDownload, WindowForBindingUI)
    return pThis->ExternalRelease();
}   

STDMETHODIMP CDownload::XWindowForBindingUI::QueryInterface(REFIID iid, void** ppvObj)
{   
    METHOD_PROLOGUE(CDownload, WindowForBindingUI)
    return (HRESULT)pThis->ExternalQueryInterface(&iid, ppvObj) ;
}   

STDMETHODIMP CDownload::XWindowForBindingUI::GetWindow(REFGUID rguidReason, HWND* phwnd)
{
    METHOD_PROLOGUE(CDownload, WindowForBindingUI)

	*phwnd = pThis->m_pView->m_hWnd;
	return S_OK;
}

