// UrlObjView.h : interface of the CUrlObjView class
//
/////////////////////////////////////////////////////////////////////////////

#include "Download.h"

class CUrlObjView : public CFormView
{
protected: // create from serialization only
	CUrlObjView();
	DECLARE_DYNCREATE(CUrlObjView)

public:
	//{{AFX_DATA(CUrlObjView)
	enum { IDD = IDD_URLOBJ_FORM };
	CString	m_classid;
	CString	m_codebase;
	int		m_width;
	int		m_height;
	int		m_major;
	int		m_minor;
	//}}AFX_DATA

	CDownload *m_download;
	CLSID m_clsid;
	LPBINDCTX m_pBindContext;
	LPBINDSTATUSCALLBACK m_pBindStatusCallback;
	CWnd m_control;

// Attributes
public:
	CUrlObjDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CUrlObjView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo*);
	//}}AFX_VIRTUAL

	afx_msg LRESULT OnStopBind(WPARAM wParam, LPARAM lParam);

// Implementation
public:
	virtual ~CUrlObjView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CUrlObjView)
	afx_msg void OnButton1();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in UrlObjView.cpp
inline CUrlObjDoc* CUrlObjView::GetDocument()
   { return (CUrlObjDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
